/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... ukazatelova aritmetika
*/

#include<iostream>
using namespace std;

//*************** VYPIS *************************************/

/* Vypis pole delky n na konzoli ... pomoci ukazatelu */
void vypis(const double *a, int n)
{
	const double *u;
	for (u = a; u < a + n; u++)
		cout <<  *u << " ";
	cout << endl;
}

/* Vypis pole delky n na konzoli ... pomoci ukazatelu */
void vypis2(const double *a, int n)
{
	for (int i = 0; i < n; i++)
		cout << *(a + i) << " ";
	cout << endl;
}

/* Vypis pole delky n na konzoli ... pomoci indexu */
void vypis1(const double *a, int n)
{
	for (int i = 0; i < n; i++)
		cout << a[i] << " ";
	cout << endl;
}

//*************** MAXIMUM *************************************/

/* Funkce vrati ukazatel na maximalni hodnotu pole a delky n  ... pomoci ukazatel */
double* maximum(double *a, int n)
{
	double *u, *m = a;
	for (u = a + 1; u < a + n; u++)
	{
		if (*u > *m)
			m = u;
	}
	return m;
}

/* Funkce vrati ukazatel na maximalni hodnotu pole a delky n  ... pomoci ukazatel */
double* maximum2(double *a, int n)
{
	int im = 0; // index maxima
	for (int i = 1; i < n; i++)
	{
		if (*(a + i) > *(a + im))
			im = i;
	}
	return a + im;
}

/* Funkce vrati ukazatel na maximalni hodnotu pole a delky n  ... pomoci indexu */
double* maximum1(double *a, int n)
{
	int im = 0; // index maxima
	for (int i = 1; i < n; i++)
	{
		if (a[i] > a[im])
			im = i;
	}
	return &a[im];
}


int main()
{
	double a[] = { 1.1,3.2,1.3,4.4,1.5,2.6,1.7,2.8,3.9,2 };
	vypis(a, 10);
	vypis2(a, 10);
	vypis1(a, 10);


	cout << *maximum(a, 10) << endl;
	cout << *maximum2(a, 10) << endl;
	cout << *maximum1(a, 10) << endl;

	// funkce vracejc l-hodnotu (ukazatel nebo referenci):
	*maximum(a, 10) = 0.1;
	vypis(a, 10);

	double *p = maximum(a, 10);
	*p = 0.1;
	vypis1(a, 10);

	return 0;
}
